/**************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.       *
*  Sites  : http://www.geocities.com/SiliconValley/Hills/8145             *
*           http://users.iol.it/joparrello                                *
*  E-Mail : joparrello@geocities.com                                      *
*                                                                         *
*  Revision:   2.1  (December 15, 1998).                                  *
*                                                                         *
*  Definition of JPFlatComboBox class.                                    *
*                                                                         *
*  Read JPFLTBOX.TXT for use and license.                                 *
*                                                                         *
*  Only for OWL 5.02 and 5.01 users.                                      *
*  OWL and ObjectWindows are trademarks of Borland International.         *
*                                                                         *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF     *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO    *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A         *
*  PARTICULAR PURPOSE.                                                    *
**************************************************************************/
#include <owl/pch.h>

#if !defined(OWL_TOOLTIP_H)
#include <owl/tooltip.h>
#endif
#if !defined(OWL_GADGETWI_H)
#include <owl/gadgetwi.h>
#endif

#include "jpfltbox.h"


//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(JPFlatComboBox, TComboBox)
//{{JPFlatComboBoxRSP_TBL_BEGIN}}
  EV_WM_CTLCOLOR,
  EV_WM_PAINT,
  EV_WM_ENABLE,
//{{JPFlatComboBoxRSP_TBL_END}}
END_RESPONSE_TABLE;

//{{JPFlatComboBox Implementation}}


JPFlatComboBox::JPFlatComboBox(TWindow* parent, int id, int x, int y, int w, int h, uint32 style, uint textLimit, TModule* module)
:
    TComboBox(parent, id, x, y, w, h, style, textLimit, module)
{
  // INSERT>> Your constructor code here.
   MouseInControl = false;
   MaxListWidth = w;
   hwndEdit = NULL;
   IsInWin31 = false;
#if defined(BI_PLAT_WIN16)
   DWORD dwVersion = ::GetVersion();
   if ((LOBYTE(LOWORD(dwVersion)) == 3) && (HIBYTE(LOWORD(dwVersion)) < 95))
      IsInWin31 = true;
#endif
}


JPFlatComboBox::~JPFlatComboBox()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.

}

/*******************************************************************************
*   This method draws the border of the combobox to make it "flat".            *
*******************************************************************************/
void JPFlatComboBox::RedrawBorder(void)
{
  TWindowDC mydc(GetHandle());
  TPoint point;
  GetCursorPos(point);
  ScreenToClient(point);
  TRect rect = GetClientRect();
  int thumbx = ::GetSystemMetrics(SM_CXHTHUMB);
  // If we are in Win31, we must paint the edit control and then draws our frame.
  if (IsInWin31)
      {
      TRect crect = rect;
      InflateRect(&crect, -2, -2);
      crect.right = crect.right - thumbx + 3;
      if (hwndEdit)
         {
         ::MoveWindow(hwndEdit, crect.left, crect.top, crect.right - crect.left,
                             crect.bottom - crect.top, true);
         ::UpdateWindow(hwndEdit);
         }
      TBrush editbrush (TColor::SysWindow);
      mydc.FrameRect(crect, editbrush);
      mydc.RestoreBrush();
      }
  if (MouseInControl)
   {              // we draw the "tracked" situation.
   TBrush brush (TColor::Sys3dFace);
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, -1, -1);
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, -1, -1);
   if (IsInWin31)
      rect.left = rect.right - thumbx + 3;
   else
      rect.left = rect.right - thumbx;
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, -1, -1);
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, 0, 1);
   rect.right += 1;
   #if defined(BI_PLAT_WIN16)
   TUIBorder intborder(rect, TUIBorder::TEdge(TUIBorder::WndRaised), TUIBorder::Rect | TUIBorder::Adjust);
   #elif defined(BI_PLAT_WIN32)
   TUIBorder intborder(rect, TUIBorder::TEdge(TUIBorder::RaisedInner), TUIBorder::Rect | TUIBorder::Adjust);
   #endif
   intborder.Paint(mydc);
   rect = GetClientRect();
   TUIBorder border(rect, TUIBorder::TStyle(TUIBorder::Recessed));
   border.Paint(mydc);
   }
else
   {              // We draw the "untracked" situation.
   TBrush brush (TColor::Sys3dFace);
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, -1, -1);
   mydc.FrameRect(rect,brush);
   ::InflateRect (&rect, -1, -1);
   mydc.FrameRect(rect,brush);
   TBrush brush2 (TColor::SysWindow);
   mydc.FrameRect(rect,brush2);
   ::InflateRect (&rect, -1, -1);
   if (IsInWin31)
      {
      if (GetStyle() && CBS_DROPDOWNLIST == CBS_DROPDOWNLIST)
         rect.left = rect.right - thumbx + 5;
      else
         rect.left = rect.right - thumbx + 4;
      }
   else
      rect.left = rect.right - thumbx + 2;
   mydc.FrameRect(rect,brush);
#if defined(BI_PLAT_WIN16)
   if (::IsWindowEnabled(hwndEdit) == false)
     {
     int x1 = rect.left - 2;
     mydc.MoveTo(x1, rect.top);
     TPen pen (TColor::Sys3dFace);
     mydc.SelectObject(pen);
     mydc.LineTo(x1, rect.bottom);
     if (IsInWin31)
        {
        x1 = x1 + 1;
        mydc.MoveTo(x1, rect.top);
        mydc.LineTo(x1, rect.bottom);
        }
     mydc.RestorePen();
     }
#endif
   }
}

/*******************************************************************************
*   This method sets the height of the combobox according to current o.s.      *
*******************************************************************************/
void JPFlatComboBox::SetupWindow()
{
  TComboBox::SetupWindow();

  // INSERT>> Your code here.
  int Height = GetItemHeight(-1);
  if (IsInWin31)
     SetItemHeight(-1, Height + 4);
  else SetItemHeight(-1, Height - 3);
}

/*******************************************************************************
*   This method sets the size of the list box, associates a tooltip to the     *
*   edit control and sets the background colour of the edit control.           *
*******************************************************************************/
HBRUSH JPFlatComboBox::EvCtlColor(HDC hDC, THandle hWndChild, uint ctlType)
{
  HBRUSH result;

  // INSERT>> Your code here.
  if (ctlType == CTLCOLOR_LISTBOX)
   {       // We change the width of the list box if MaxListWidth is unlike zero.
   RECT rect;
   ::GetWindowRect(hWndChild, &rect);
   if ((rect.right - rect.left)!=MaxListWidth)
      ::SetWindowPos(hWndChild, HWND_TOPMOST, rect.left, rect.top, MaxListWidth, rect.bottom - rect.top, SWP_FRAMECHANGED);
   }
  else if (ctlType == CTLCOLOR_EDIT)
         {  // We assign our string to the tooltip.
         if (!hwndEdit)
            InsertEditTooltip(hWndChild);
#if defined(BI_PLAT_WIN16)
         else if (::IsWindowEnabled(hwndEdit) == false)
              {
              ::SetBkColor(hDC, TColor::Sys3dFace);
              return (HBRUSH) TBrush(TColor::Sys3dFace);
              }
#endif
         }
  result = TComboBox::EvCtlColor(hDC, hWndChild, ctlType);
  return result;
}

/*******************************************************************************
*   This method paints the combobox and then the flat borders.                 *
*******************************************************************************/
void JPFlatComboBox::EvPaint()
{
    TComboBox::EvPaint();

  // INSERT>> Your code here.
    RedrawBorder();
}

/*******************************************************************************
*   This method assign our resource string to the tooltip.                     *
*******************************************************************************/
void JPFlatComboBox::InsertEditTooltip(HWND editHwnd)
{
  TWindow* tWin = GetParentO();
  string text = LoadInternalString(GetId());
  if (tWin && text.length())
     {
     TGadgetWindow* gWin = TYPESAFE_DOWNCAST(tWin, TGadgetWindow);
     if (gWin)
        {
        TTooltip* tTip = gWin->GetTooltip();
        if (tTip)
           {
           TToolInfo toolInfo((HWND) gWin->GetHandle(), (HWND) GetHandle());
           if (tTip->GetToolInfo(toolInfo))
              {
              toolInfo.SetToolInfo(editHwnd, gWin->GetHandle());
              #if defined(BI_PLAT_WIN32)
              toolInfo.SetText(text.c_str(), false);
              #elif defined(BI_PLAT_WIN16)
              toolInfo.SetText(text.c_str(), true);
              #endif
              tTip->AddTool(toolInfo);
              }
           }
        }
     }
  hwndEdit = editHwnd;
  if (IsInWin31)
     Invalidate(false);
}

/*******************************************************************************
*   This method checks if mouse is inside our combobox.                        *
*   Then we draw the borders of the combobox according to this checking.       *
*******************************************************************************/
bool JPFlatComboBox::IdleAction(long idleCount)
{
  // INSERT>> Your code here.
  if ((idleCount == 0) && IsWindowEnabled())
     {
     TPoint point;
     GetCursorPos(point);
     ScreenToClient(point);
     TRect rect = GetClientRect();
     if (PtInRect(&rect, point))
        {
        if (MouseInControl == false)
           {
           MouseInControl = true;
           Invalidate(false);
           }
        }
     else
        {
        if (MouseInControl == true)
           {
           MouseInControl = false;
           Invalidate(false);
           }
        }
     }
  return false;
}

/*******************************************************************************
*   This method retrieves the resource string for the edit control (it's the   *
*   same as the combobox's resource string).                                   *
*******************************************************************************/
string JPFlatComboBox::LoadInternalString(uint menuItemId)
{
	char szBuf[255];

   strcpy(szBuf,"");
   TWindow* parent= GetParentO();
   TDecoratedFrame* frame= parent ?
                           TYPESAFE_DOWNCAST(parent, TDecoratedFrame) : 0;
   while (parent && !frame)
   {
     parent = parent->GetParentO();
     if (parent)
       frame = TYPESAFE_DOWNCAST(parent, TDecoratedFrame);
   }
   if (frame)
		frame->GetHintText(menuItemId, szBuf, sizeof(szBuf), htTooltip);
   return string(szBuf);
}

/*******************************************************************************
*   This method sets the maximum width of the list box.                        *
*******************************************************************************/
int JPFlatComboBox::SetListBoxWidth(uint newwidth)
{
  MaxListWidth = newwidth;
  return MaxListWidth;
}

/*******************************************************************************
*   This method retrieves the maximum width of the list box.                   *
*******************************************************************************/
uint JPFlatComboBox::GetListBoxWidth() const
{
  return (uint) MaxListWidth;
}

// If the mouse is over the Combo-Box and we want to disable it, we must paint
// the normal combo-box before disabling it.
void JPFlatComboBox::EvEnable(bool enabled)
{
    TComboBox::EvEnable(enabled);

  // INSERT>> Your code here.
  if (!enabled && MouseInControl)
     {
     MouseInControl = false;
     Invalidate(false);
     }
}

