/**************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.       *
*  Sites  : http://www.geocities.com/SiliconValley/Hills/8145             *
*           http://users.iol.it/joparrello                                *
*  E-Mail : joparrello@geocities.com                                      *
*                                                                         *
*  Revision:   2.1  (December 15, 1998).                                  *
*                                                                         *
*  Definition of JPFlatComboBox class.                                    *
*                                                                         *
*  Read JPFLTBOX.TXT for use and license.                                 *
*                                                                         *
*  Only for OWL 5.02 and 5.01 users.                                      *
*  OWL and ObjectWindows are trademarks of Borland International.         *
*                                                                         *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF     *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO    *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A         *
*  PARTICULAR PURPOSE.                                                    *
**************************************************************************/
#if !defined(jpfltbox_h)
#define jpfltbox_h

#include <owl/combobox.h>
#include <owl/uihelper.h>
#include <owl/dc.h>

//{{TComboBox = JPFlatComboBox}}
class JPFlatComboBox : public TComboBox {
  public:
    JPFlatComboBox(TWindow* parent,
                   int id,
                   int x,
                   int y,
                   int w,
                   int h,
                   uint32 style,
                   uint textLimit,
                   TModule* module = 0);
    virtual ~JPFlatComboBox();

//{{JPFlatComboBoxVIRTUAL_BEGIN}}
  public:
    int 		SetListBoxWidth(uint newwidth);
    uint 	GetListBoxWidth() const;
//{{JPFlatComboBoxVIRTUAL_END}}

//{{JPFlatComboBoxRSP_TBL_BEGIN}}
  protected:
    HWND 	hwndEdit;
    bool 	MouseInControl;
    int  	MaxListWidth;
    bool 	IsInWin31;

  protected:
    void 	RedrawBorder(void);
    void 	InsertEditTooltip(HWND hwndEdit);
    HBRUSH 	EvCtlColor(HDC hDC, THandle hWndChild, uint ctlType);
    void 	EvPaint();
    void 	SetupWindow();
    bool 	IdleAction(long idleCount);
    string 	LoadInternalString(uint menuItemId);
    void EvEnable(bool enabled);
    //{{JPFlatComboBoxRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(JPFlatComboBox);
};    //{{JPFlatComboBox}}

#endif  // jpfltbox_h sentry.

